/* LadeFile.ced
   von Timo Westen
*/

/* Diese Zeile angeben, wenn das
   Rexx-Skript vom CLI/Shell ausgefhrt wird

   ADDRESS 'rexx_ced'
*/

OPTIONS RESULTS
COPY BLOCK  /* Block kopieren */
STATUS 60   /* Block in RESULT */
Datei=RESULT
DMark=Datei  /* Alten Block merken, falls die Datei */
             /* nicht vorhanden ist */
/* Datei laden */
IF ~EXISTS(Datei) THEN DO
  IF EXISTS('include:'Datei) THEN Datei='include:'Datei
  ELSE DO /* Keine Datei markiert */
    Mark1='<'; Mark2='>'; CALL FindMark; IF RESULT THEN GoOn
    Mark1='{'; Mark2='}'; CALL FindMark; IF RESULT THEN GoOn
    Mark1='('; Mark2=')'; CALL FindMark
    GoOn:
    IF ~EXISTS(Datei) THEN DO
      IF EXISTS('include:'Datei) THEN Datei='include:'Datei
      ELSE Datei=DMark
    END
  END
END

/* Aktuellen Dateinamen im Block lschen */
MARK BLOCK; TEXT ""; CUT BLOCK

OPEN NEW /* Neues Fenster ffnen */
OPEN Datei
EXIT

/* Diese Funktion ermittelt den in Klammern
   stehenden Text
*/
FindMark:
STATUS 55
newline=RESULT
IF LENGTH(newline)=1 THEN EXIT 0
STATUS 46
/* Position der linken Markierung */
l=LASTPOS(Mark1,newline,RESULT)
/* Position der rechten Markierung */
r=POS(Mark2,newline,RESULT)
x=0
if (0~=l*r) & (l<r) THEN DO
  /* Wir haben etwas gefunden */
  STATUS 47 /* Y-Postition in RESULT */
  y=RESULT
  JUMPTO y+1 l+1 /* Markiere den Inhalt */
  MARK BLOCK
  JUMPTO y+1 r
  COPY BLOCK
  STATUS 60
  Datei=RESULT
  x=1 /* Fertig */
END
RETURN x
